## ros-eloquent-interactive-markers 2.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(interactive_markers)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rmw REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(visualization_msgs REQUIRED)

ament_python_install_package(${PROJECT_NAME})

add_library(${PROJECT_NAME} SHARED
  src/interactive_marker_server.cpp
  src/tools.cpp
  src/menu_handler.cpp
  src/interactive_marker_client.cpp
  src/message_context.cpp
)
target_include_directories(${PROJECT_NAME} PUBLIC include)
ament_target_dependencies(${PROJECT_NAME}
  "rclcpp"
  "rmw"
  "tf2"
  "tf2_geometry_msgs"
  "visualization_msgs")

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

install(
  DIRECTORY include/
  DESTINATION include)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME}
  PRIVATE "INTERACTIVE_MARKERS_BUILDING_LIBRARY")

ament_export_dependencies("rclcpp")
ament_export_dependencies("rmw")
ament_export_dependencies("tf2")
ament_export_dependencies("tf2_geometry_msgs")
ament_export_dependencies("visualization_msgs")
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  find_package(geometry_msgs REQUIRED)
  find_package(std_msgs REQUIRED)

  ament_lint_auto_find_test_dependencies()

  ament_add_gtest(test_interactive_marker_server
    test/${PROJECT_NAME}/test_interactive_marker_server.cpp
  )
  ament_target_dependencies(test_interactive_marker_server
    "geometry_msgs"
    "rclcpp"
    "std_msgs"
  )
  target_link_libraries(test_interactive_marker_server
    ${PROJECT_NAME}
  )

  ament_add_gtest(test_interactive_marker_client
    test/${PROJECT_NAME}/test_interactive_marker_client.cpp
  )
  ament_target_dependencies(test_interactive_marker_client
    "geometry_msgs"
    "rclcpp"
    "std_msgs"
    "tf2"
  )
  target_link_libraries(test_interactive_marker_client
    ${PROJECT_NAME}
  )
endif()

ament_package()

=== debian/changelog ===
ros-eloquent-interactive-markers (2.0.1-1bionic) bionic; urgency=high

  * Fix test flakes by waiting for pub/sub discovery (#55 <https://github.com/ros-visualization/interactive_markers/issues/55>)
  * Add parameters for QoS of update and feedback topics (#54 <https://github.com/ros-visualization/interactive_markers/issues/54>)
  * Port Python implementation to ROS 2 (#53 <https://github.com/ros-visualization/interactive_markers/issues/53>)
    * Move Python files to their own directory
    * Install Python via ament_cmake_python
    * Make Python implementation ROS 2 compatible
    * Use docstrings
    * Minor refactor of callback logic
    * Guard against None values and KeyError's
    * Change insert() signature to take keyword arguments
    * Rename variables for clarity (e.g. 'cb' -> 'callback')
    * Fix PEP 257 errors
    * Remove unused setup.py
    * Enable flake8 tests and fix errors
    * Improve performance
    * Clear pending updates after applying all of them
    * Don't rely on user to apply any pose updates
    * Expose QoSProfile a parameter
    * Add Python implementation dependencies to package.xml
  * Contributors: Jacob Perron

 -- William Woodall <william@osrfoundation.org>  Wed, 23 Oct 2019 07:00:00 -0000

ros-eloquent-interactive-markers (2.0.0-1bionic) bionic; urgency=high

  * Add missing visibility macros (#51 <https://github.com/ros-visualization/interactive_markers/issues/51>)
  * Less verbose logging (#45 <https://github.com/ros-visualization/interactive_markers/issues/45>)
  * Rename enums to avoid collisions with MSVC compiler defines (#49 <https://github.com/ros-visualization/interactive_markers/issues/49>)
  * Catch polymorphic exceptions by reference (#48 <https://github.com/ros-visualization/interactive_markers/issues/48>)
  * Port to ROS 2 (#44)
    
    Style and other aesthetic changes
    
    Use tf2::BufferCoreInterface
    
    Replace 'init' topic with a ROS service
    
    Merge SingleClient logic into InteractiveMarkerClient
    
    Remove notion of server ID
    
    Add feedback publisher to client
    
    Default to C++14 and set stricter compiler flags
    
    Fix Windows compiler warnings
    
    Remove StateMachine class
    
    Fix Clang warnings
  * Contributors: David Gossow, Jacob Perron, Scott K Logan

 -- William Woodall <william@osrfoundation.org>  Thu, 26 Sep 2019 07:00:00 -0000

ros-eloquent-interactive-markers (1.11.4-1bionic) bionic; urgency=high

  * Fixed a crash when updates arrive, or are being processed, while shutdown is called (#36 <https://github.com/ros-visualization/interactive_markers/issues/36>)
  * Contributors: Simon Schmeisser

 -- William Woodall <william@osrfoundation.org>  Mon, 16 Apr 2018 07:00:00 -0000

ros-eloquent-interactive-markers (1.11.3-1bionic) bionic; urgency=high

  * The ``processFeedback`` function of the menu handler no longer catches the ``KeyErrors`` of the feedback_cb.
    See: #29 <https://github.com/ros-visualization/interactive_markers/issues/29>
  * Added the ``empty()`` and ``size()`` members to ``InteractiveMarkerServer`` interface.
    See: #30 <https://github.com/ros-visualization/interactive_markers/issues/30>
  * Contributors: Blake Anderson, Guglielmo Gemignani

 -- William Woodall <william@osrfoundation.org>  Wed, 24 Aug 2016 07:00:00 -0000

ros-eloquent-interactive-markers (1.11.2-1bionic) bionic; urgency=high

  * Fix build when disabling tests with ``-DCATKIN_ENABLE_TESTING=OFF``.
    See: #26 <https://github.com/ros-visualization/interactive_markers/issues/26>
  * Fix use of uninitialized variables.
    See: #24 <https://github.com/ros-visualization/interactive_markers/issues/24>
  * Fix potential segfault when shutting down.
    See: #25 <https://github.com/ros-visualization/interactive_markers/issues/25>
  * Contributors: Alexis Ballier, David Gossow, Max Schwarz

 -- William Woodall <william@osrfoundation.org>  Wed, 24 Aug 2016 07:00:00 -0000

ros-eloquent-interactive-markers (1.11.1-1bionic) bionic; urgency=high

  * Added explicit keyword argument queue_size for publisher in Python code and use the same default queue_size value as C++.
  * Fixed a SEGFAULT in setPose reported in #18 <https://github.com/ros-visualization/interactive_markers/issues/18>
    Previously, calling setPose() on an interactive marker causes a SEGFAULT
    if applyChanges() was not called on the server at least once since the
    marker was created. I traced the actual SEGFAULT to the doSetPose
    function. The value of header passed from setPose() is invalid because,
    in this case, marker_context_it = marker_contexts_.end().
    I added a check for this case and, if there is no marker is present,
    instead use the header from the pending update.
  * Contributors: David Gossow, Mike Koval, William Woodall, ipa-fxm

 -- William Woodall <william@osrfoundation.org>  Tue, 16 Dec 2014 08:00:00 -0000

ros-eloquent-interactive-markers (1.11.0-1bionic) bionic; urgency=high

  * Adding William Woodall as maintainer
  * fix threading bugs
    Fix locking of data structures shared across threads.
  * Contributors: Acorn Pooley, William Woodall, hersh

 -- William Woodall <william@osrfoundation.org>  Mon, 24 Feb 2014 08:00:00 -0000

ros-eloquent-interactive-markers (1.10.2-1bionic) bionic; urgency=high

  * fix regression in menu_handler.py
    fixes #14 <https://github.com/ros-visualization/interactive_markers/issues/14>
  * Contributors: William Woodall

 -- William Woodall <william@osrfoundation.org>  Mon, 03 Feb 2014 08:00:00 -0000

ros-eloquent-interactive-markers (1.10.1-1bionic) bionic; urgency=high

  * cleanup python code and package contents
  * remove useless dependencies
  * Contributors: Vincent Rabaud, William Woodall

 -- William Woodall <william@osrfoundation.org>  Mon, 27 Jan 2014 08:00:00 -0000

ros-eloquent-interactive-markers (1.10.0-1bionic) bionic; urgency=high

  * remove debug statement that could produce segfault; init_it->msg->markers may be empty


=== debian/control ===
Source: ros-eloquent-interactive-markers
Section: misc
Priority: optional
Maintainer: William Woodall <william@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-eloquent-ament-cmake, ros-eloquent-ament-cmake-gtest, ros-eloquent-ament-cmake-python, ros-eloquent-ament-lint-auto, ros-eloquent-ament-lint-common, ros-eloquent-geometry-msgs, ros-eloquent-rclcpp, ros-eloquent-rmw, ros-eloquent-tf2, ros-eloquent-tf2-geometry-msgs, ros-eloquent-visualization-msgs, ros-eloquent-ros-workspace
Homepage: http://ros.org/wiki/interactive_markers
Standards-Version: 3.9.2

Package: ros-eloquent-interactive-markers
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-eloquent-builtin-interfaces, ros-eloquent-rclcpp, ros-eloquent-rclpy, ros-eloquent-rmw, ros-eloquent-std-msgs, ros-eloquent-tf2, ros-eloquent-tf2-geometry-msgs, ros-eloquent-visualization-msgs, ros-eloquent-ros-workspace
Description: 3D interactive marker communication library for RViz and similar tools.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/eloquent/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/eloquent" \
		-DAMENT_PREFIX_PATH="/opt/ros/eloquent"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-eloquent-interactive-markers//opt/ros/eloquent/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_install
